//============================================================================
//	apci8132s.pas
//
//	aPCI-8132
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.10 Date 1999/05/31
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//============================================================================
unit apci8132s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci8132w;

const
	szTitle = 'Sample';
	sz8132  = 'aPCI-8132';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//	۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
	wLogSlot:	Word;								// ޲̘_ۯĔԍi[
	Ri:				TAPCI8132RESOURCE;	// ؿ
	dwDLLVer, dwDriverVer: DWord;
	dwSwVal:	DWord;							// ۰ذ̒l
	cbDat:		Byte;
	bResult:	Boolean;						// 
	szBuf:		String;
begin
	//-------------------------------------------------
	// apci8132.dll ̎gp錾
	//-------------------------------------------------
	if Apci8132wDllOpen() = False then begin
		ErrorMessage(APCI8132_SLOT_AUTO);
		Exit;											// apci8132.dll ۰ނɎs܂
	end;
	//-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-8132 DLL,ײްްޮݔԍ擾
	//-------------------------------------------------
	if Apci8132wGetVersion(dwDLLVer, dwDriverVer) = False then begin
		ErrorMessage(APCI8132_SLOT_AUTO);
		Exit;
	end;

	szBuf := Format('GetVersion'#10 +
									'DLL Version'#09+ ': %08xH'#10 +
									'Driver Version'#09+ ': %08xH',
									[dwDLLVer, dwDriverVer]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8132̎gp錾
	//-------------------------------------------------
	wLogSlot := APCI8132_SLOT_AUTO;				// gp޲T܂B
	bResult := Apci8132wCreate(wLogSlot);	// ꍇA̎޲̘_ۯĔԍi[܂B
	if bResult = False then begin					// ޲܂B
		ErrorMessage(APCI8132_SLOT_AUTO);
		Exit;
	end;
	szBuf := Format('aPCI-8132 Created'#10#10 +
								  'LogSlot: %2d'
									,[wLogSlot]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-------------------------------------------------
	if Apci8132wGetResource(wLogSlot, Ri) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	if Apci8132wGetSwitchValue(wLogSlot, dwSwVal) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Board Name'#09  + ': %s'#10 +
									 'IO Address'#09  + ': %04xH-%04xH'#10 +
									 'EICR Address'#09+ ': %04xH-%04xH'#10 +
									 'Switch'#09#09   + ': %02xH',
									 [sz8132,
										Ri.dwIOPortBase[2],
										Ri.dwIOPortBase[2] + Ri.dwIOPortLength[2] - 1,
										Ri.dwIOPortBase[1],
										Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
										dwSwVal]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port 1 ްǂݍ
	//-------------------------------------------------
	cbDat := Byte($00);
	if Apci8132wInPort(wLogSlot, APCI8132_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 f[^'#10 +
									 'Port 1 In Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8132̎gpJ
	//-------------------------------------------------
	if Apci8132wClose(wLogSlot) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('aPCI-8132 Closed');
	//-------------------------------------------------
	// apci8132.dll ̎gpJ
	//-------------------------------------------------
	if Apci8132wDllClose() = False then begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;
	end;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Apci8132wGetLastError(wLogSlot);
	case dwRes of
		APCI8132_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		APCI8132_ERR_WRAPDLL:
    	szBuf := 'DLL Load error';
		else
			szBuf := Format('aPCI-8132 error'#10#10'Error code: %08xH',[dwRes]);
  end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

