/*============================================================================
//	apci8132w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/07/15
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci8132w.h"	/* aPCI-8132 */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci8132wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci8132GetVersion = NULL;
static FARPROC pApci8132Create = NULL;
static FARPROC pApci8132Close = NULL;
static FARPROC pApci8132GetResource = NULL;
static FARPROC pApci8132InPort = NULL;
static FARPROC pApci8132GetLastError = NULL;
static FARPROC pApci8132GetSwitchValue = NULL;

/*============================================================================
// 	  apci8132.dll۰(۰ގʹװƂ)	
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI8132_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci8132wGetDllExportFunc();
			if (TRUE != Result)
				Apci8132wDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  apci8132.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  aPCI-8132 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8132GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  aPCI-8132̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8132Create)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  aPCI-8132̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8132Close)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wGetResource(WORD wLogSlot, PAPCI8132R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8132GetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8132InPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  aPCI-8132̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci8132wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI8132_ERR_WRAPDLL;
	else
		return (*pApci8132GetLastError)(wLogSlot);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8132wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8132GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci8132wGetDllExportFunc()
{
	/* Apci8132GetVersion ̱ڽ擾 */
	pApci8132GetVersion = GetProcAddress(hDLL, _T("Apci8132GetVersion"));
	if (pApci8132GetVersion == NULL)
		return FALSE;

	/* Apci8132Create ̱ڽ擾 */
	pApci8132Create = GetProcAddress(hDLL, _T("Apci8132Create"));
	if (pApci8132Create == NULL)
		return FALSE;

	/* Apci8132Close ̱ڽ擾 */
	pApci8132Close = GetProcAddress(hDLL, _T("Apci8132Close"));
	if (pApci8132Close == NULL)
		return FALSE;

	/* Apci8132GetResource ̱ڽ擾 */
	pApci8132GetResource = GetProcAddress(hDLL, _T("Apci8132GetResource"));
	if (pApci8132GetResource == NULL)
		return FALSE;

	/* Apci8132InPort ̱ڽ擾 */
	pApci8132InPort = GetProcAddress(hDLL, _T("Apci8132InPort"));
	if (pApci8132InPort == NULL)
		return FALSE;

	/* Apci8132GetLastError ̱ڽ擾 */
	pApci8132GetLastError = GetProcAddress(hDLL, _T("Apci8132GetLastError"));
	if (pApci8132GetLastError == NULL)
		return FALSE;

	/* Apci8132GetSwitchValue ̱ڽ擾 */
	pApci8132GetSwitchValue = GetProcAddress(hDLL, _T("Apci8132GetSwitchValue"));
	if (pApci8132GetSwitchValue == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
